*  Program...........: LIBRARY.PRG
*  Author............: Valdis Matison
*} Project...........: Common Library
*  Created...........: 10/16/93
*  Copyright.........: (c) Matison Consulting Group Inc., 1993
*) Description.......: 
*] Dependencies......: 
*  Calling Samples...: 
*  Parameter List....: 
*  Returns...........: 
*  Major change list.: 03/26/94: Added material to li_movewin; removed exit option


procedure li_yesno
*-- Modified: 12/15/92

PARAMETERS lc_message,ll_yes
private ln_choice

if parameters()=1	&& default to false
 ll_yes=.f.
endif

ln_choice = iif( ll_yes, 1, 2 )

if gl_beep
 ?? chr(7)
endif

IF NOT WEXIST("yesno")
	DEFINE WINDOW yesno ;
		FROM INT((SROW()-7)/2),INT((SCOL()-75)/2) ;
		TO INT((SROW()-7)/2)+6,INT((SCOL()-75)/2)+74 ;
		FLOAT ;
		NOCLOSE ;
		SHADOW ;
		DOUBLE ;
		COLOR SCHEME 7
ENDIF

IF WVISIBLE("yesno")
	ACTIVATE WINDOW yesno SAME
ELSE
	ACTIVATE WINDOW yesno NOSHOW
ENDIF

@ 1,3 SAY lc_message ;
	SIZE 1,68
@ 3,28 GET ln_choice ;
	PICTURE "@*HT \!\<Ok;\?\<Cancel" ;
	SIZE 1,8,1 ;
	DEFAULT 1

IF NOT WVISIBLE("yesno")
	ACTIVATE WINDOW yesno
ENDIF

READ CYCLE MODAL object ln_choice

RELEASE WINDOW yesno

#REGION 1
return iif(ln_choice=1, .t., .f. )


procedure li_movemsg
*--
*-- Last update: 08/15/93
*--
private ln_obj
ln_obj = OBJNUM( ln_positn )

Do case
 case _CUROBJ = ln_obj 
  return li_msglist("GOFIRST")

 case _CUROBJ = ln_obj + 1 
  return li_msglist("GONEXT")

 case _CUROBJ = ln_obj + 2
  return li_msglist("GOPREVIOUS")

 case _CUROBJ = ln_obj + 3
  return li_msglist("GOBOTTOM")

 case _CUROBJ = ln_obj + 4
  return li_msglist("SCREXIT")

 case _CUROBJ = ln_obj + 4
  return li_msglist("PRESSTOBRO")

 otherwise
  return ""
endcase


*~!*********************************************
*~!
*~!       Procedure: li_waitmsg     
*~!
*~!*********************************************
PROCEDURE li_waitmsg     
*~  Author............: Valdis Matison
*~  Modified by.......: 
*~} Project...........: 
*~  Created...........: 11/05/93
*~  Copyright.........: (c) Matison Consulting Group Inc., 1993
*~) Description.......: Returns a string to the wait window or to a string
*~)                     
*~] Dependencies......: 
*~  Calling Samples...: 
*~  Parameter List....: lc_msgkey : indexed variable used to find the message
*~                    : ll_bell   : tells me to ring the bell or not
*~                    : ll_wait   : true sends string to wait window; false returns string
*~                    : lc_message: display this string if sent
*~                    : ln_timeout: tells how long to keep msg; 0 means infinite
*~                    : lc_warning: specifies the colour of the wait message
*~                    :             "R" Means Red; used for critical areas
*~                    :             "Y" means Yellow; general warnings
*~                    :             "G" or nothing/blank is for general messages
*~  Returns...........: 
*~  Future ideas......: 
*~  Major change list.: 
 
parameters lc_msgkey, ;
           ll_bell, ;
           ll_wait, ;
           lc_message, ;
           ln_timeout, ;
           lc_warning

private lc_waitmsg, ;
        lc_schem5

lc_waitmsg = ""

if empty( lc_message )
 lc_waitmsg  = li_msglist( lc_msgkey )
else
 lc_waitmsg  = lc_message
endif

if ll_bell
 ?? chr(7)
endif

if empty( lc_warning )
 lc_warning = " "
endif

if ll_wait
*-- New stuff
 lc_schem5 = scheme(5)

 do case
  case lc_warning = "R"
  SET COLOR OF SCHEME 5 TO W+/R,w+/r,w+/r
  case lc_warning = "Y"
  SET COLOR OF SCHEME 5 TO gr+/n, gr+/n, gr+/n
 endcase
*-- End of new stuff

 if empty( ln_timeout )
  wait lc_waitmsg window nowait

 else
  wait lc_waitmsg window timeout ln_timeout

 endif

 SET COLOR OF SCHEME 5 TO ( lc_schem5 )

else
 return lc_waitmsg

endif

* eop lc_waitmsg


procedure li_msglist
*-- Procedure returns a message string from an open file
*--
*-- Last update 03/06/93
*--
*-- I don't want to clutter up my program files with a bunch of messages
*-- Just send down the name and the procedure will look it up
*-- and return the string
*-- It is assumed that the message file is always open and that the 
*-- tag is set to the message key field
*-- A blank is returned if nothing found.
*--
parameters lc_msgname
private ll_found
*ll_found = seek(lc_msgname, "LI_MSG" )
if seek(lc_msgname, "LI_MSG" )
 return trim( li_msg.message )
else
 return ""
endif



procedure li_tagpop
*--
*-- Last update: 03/31/93
*--
*-- Creates a popup and bar for every active tag in a file
*--

private ln_k, ;
        ln_barcnt, ;
        ln_tag, ;
        ln_sys21, ;
        lc_alias

external array ga_tagname

ln_tag    = 0
ln_k      = 1
ln_barcnt = 1
ln_sys21  = val( sys( 21 ) )
lc_alias  = alias()

*-- Create the order popup for every tag in this master file
if .not. empty( tag( 1 ) )

DEFINE POPUP lp_order MARGIN RELATIVE SHADOW COLOR SCHEME 4

do while .not. empty(tag(ln_k))
 if upper( trim( tag( ln_k ) ) ) <> "DELETED"

  define bar ln_barcnt of lp_order prompt li_msglist( lc_alias+tag( ln_k ) )
  ga_tagname[ ln_barcnt ] = tag( ln_k )

  ln_barcnt = ln_barcnt + 1

 else
  ln_tag = ln_k

 endif
 ln_k = ln_k + 1
enddo

on bar 6 OF _record activate popup lp_order
on selection popup lp_order do li_setord with prompt(), bar()
*-- sys(21) returns current tag in use so this will mark the bar

*-- Mark the popup

if ln_tag = 1									&& If first tag is deleted
 set mark of bar ln_sys21 - 1 of lp_order .t.	&& Shift back one since I won't have a delted bar
else
 set mark of bar ln_sys21 of lp_order .t.	&& mark first bar since probably  used
endif

endif

return
* eop


procedure li_setord
*--
*-- Last update: 07/11/93
*-- 
*-- Selection routine for li_tagpop
*-- Sets order and seek messages for any screen
*-- ln_bar contains a refernece to the tag number
*-- 
*-- Note:  The table must be open and selected for this to work properly
*--
parameters lc_bar, ln_bar

external array ga_tagname

if seek( alias() + ga_tagname[ ln_bar ] , "LI_FLIST" )

*if seek( alias() + lc_bar, "LI_FLIST" )
 gc_key       = LI_FLIST.key
 gc_fldname   = LI_FLIST.fldname
 gc_seekmsg   = LI_FLIST.seekmsg

endif

 set order to tag ( ga_tagname[ ln_bar ] )

* set order to tag ( lc_bar )
 set mark of popup lp_order .f.		&& turn all off
 set mark of bar ln_bar of lp_order .t.	&& now mark just one

*--
*-- Note that the browse window name musn't be:
*-- "< Inventory Location >" but should be:
*-- "Inventory Location"
*--

if gl_browsin
 lc_top = wontop()
 show window ( wontop() ) refresh
endif

return


*~!*********************************************
*~!
*~!       Procedure: li_add         
*~!
*~!*********************************************
PROCEDURE li_add         
*~  Author............: Valdis Matison
*~  Modified by.......: 
*~} Project...........: 
*~  Created...........: 04/04/1994
*~  Copyright.........: (c) Matison Consulting Group Inc., 1994
*~) Description.......: Basic Add/Edit setup
*~)                     
*~] Dependencies......: 
*~  Calling Samples...: 
*~  Parameter List....: Send down add, edit, and object
*~  Returns...........: 
*~  Future ideas......: 
*~  Major change list.: 

parameters lc_action, ln_obj

private lc_scheme1, ln_recno

lc_scheme1 = scheme(1)
ln_recno   = recno()

if li_reclock()			&& Only change a record if I can lock it

 _curobj    = 1

 do case

  case lc_action = "ADD"
   gl_editing = .t.		&& Switch to .f. in li_okcanc
   gl_adding  = .t.		&& Switch to .f. in li_okcanc
   scatter memvar memo blank

*--
*-- This is done to position the record pointer at end of file
*-- so related tables are also moved eof. When a show gets off is
*-- issued, the related items will display as blanks
*--

   if !eof()
    go bottom
    skip
    go ln_recno
   endif

*-- Come and fix the next line
   show gets

  case lc_action = "EDIT"

   if !eof()
    scatter memvar memo
    gl_editing = .t.		&& Switch to .f. in li_okcanc
    show gets 
   else
    =msgbox( li_msglist("EOF"), wtitle(wontop()), 48 )
   endif

 endcase

if gl_editing
 show get mn_exit    disable
 show get mn_positn  disable
 show get mn_addedit disable
 show get mn_desepr  disable
 show get mn_okcanc  enable
 show get mn_order   disable
endif

endif
clear typeahead
return

*-- eop li_add


*~!*********************************************
*~!
*~!       Procedure: li_okcanc      
*~!
*~!*********************************************
PROCEDURE li_okcanc      
*~  Author............: Valdis Matison
*~  Modified by.......: 
*~} Project...........: 
*~  Created...........: 03/31/1994
*~  Copyright.........: (c) Matison Consulting Group Inc., 1994
*~) Description.......: PROCEDURE li_okcanc      
*~)                     OK/ Cancel termination during Add/Edit cycle of read
*~] Dependencies......: 
*~  Calling Samples...: 
*~  Parameter List....: 
*~  Returns...........: 
*~  Future ideas......: 
*~  Major change list.: 
 
parameters ln_action
private lc_choice, ;
        lc_dbf, ;
        ln_isok

lc_choice = substr( "OCD", ln_action, 1 )
lc_dbf    = alias()
ln_isok   = 0

do case

 case lc_choice = "O"			&& OK Pressed in screen push button
  if gl_adding
   insert into ( lc_dbf ) from memvar
  else
   gather memvar memo
  endif

 case lc_choice = "C"			&& Cancel pressed
  scatter memvar memo
  show gets

endcase

*-- come back to this point
unlock		&& I'm assuming that I'm unlocking one record in the current table

show get mn_exit    enable
show get mn_positn  enable
show get mn_addedit enable
show get mn_desepr  enable
show get mn_okcanc  disable
show get mn_order   enable

gl_adding  = .f.	&& set in rec_add or rec_edit
gl_editing = .f.	&& set in rec_add or rec_edit

*--
*-- Set the first button as default
*-- 
_curobj = objnum( mn_positn )

return .t.


*~!*********************************************
*~!
*~!       Procedure: li_delete      
*~!
*~!*********************************************
PROCEDURE li_delete      
*~  Author............: Valdis Matison
*~  Modified by.......: 
*~} Project...........: 
*~  Created...........: 04/01/1994
*~  Copyright.........: (c) Matison Consulting Group Inc., 1994
*~) Description.......: Prompts user for record deletion
*~)                     Windows only version
*~] Dependencies......: Foxtools.fll must be loaded
*~  Calling Samples...: 
*~  Parameter List....: lc_show = "S" means do a show gets after the delete
*~  Returns...........: 
*~  Future ideas......: 
*~  Major change list.: 
 
parameters lc_show
private ln_isok

ln_isok = 0
ln_isok = msgbox( li_msglist( "ASKTODELE" ), wtitle(wontop()), 36)

if ln_isok = 6
 return li_recdel( lc_show )
else
 return .f.
endif

*-- eop li_delete


*~!*********************************************
*~!
*~!       Procedure: li_recdel      
*~!
*~!*********************************************
PROCEDURE li_recdel      
*~  Author............: Valdis Matison
*~  Modified by.......: 
*~} Project...........: 
*~  Created...........: 04/01/1994
*~  Copyright.........: (c) Matison Consulting Group Inc., 1994
*~) Description.......: Deletes records without asking first
*~)                     Called either alone or from li_delete
*~)                     Windows version
*~] Dependencies......: 
*~  Calling Samples...: 
*~  Parameter List....: lc_show = "S" means do a show gets after the delete
*~  Returns...........: 
*~  Future ideas......: 
*~  Major change list.: 
 
parameters lc_show
private lc_showget

if empty( lc_show )
 lc_showget = ""
else
 lc_showget = lc_show
endif

IF EOF()
  =msgbox( li_msglist("EOF"), wtitle(wontop()), 48 )
   RETURN .F.
ENDIF

private lc_alias, ;
        lc_exact, ;
        ll_oktodel, ;
        lc_chldals, ;
        lc_forkey, ;
        lc_order, ;
        ll_okscan

lc_exact   = set("EXACT")
lc_alias   = alias()
ll_oktodel = .f.
lc_chldals = ""			&& Name of child alias. Look up in li_flist
ll_okscan  = .t.

*--
*-- See if any delete rules exist for this table
*-- The same delete rule must apply to all tables
*-- i.e. I can't have set to null for one child table and restrict
*-- for another table. THIS MIGHT BE CHANGED IN THE FUTURE
*-- 
 
if seek( lc_alias, "LI_RELS" )		&& Entries in delete rules table
   do case
    case li_rels.delrule = "C"		&& Cascade 
     select li_rels.childdbf, ;
            li_rels.parentcol, ;
            li_rels.childcol ;
       from li_rels ;
      where li_rels.dbfname = lc_alias ;
       into cursor lq_temp

     select lq_temp
     scan

      lc_dbf = alltrim( childdbf )
      lc_chldfld = alltrim( childcol )
      lc_parent = eval( lc_alias + "." + ;
                  trim( li_rels.parentcol ) )

      select ( lc_dbf )
      go top
      delete for eval( lc_chldfld ) = lc_parent
      select lq_temp
 
     endscan
     use
     select ( lc_alias )
     ll_oktodel = .t.

    case li_rels.delrule = "N"		&& Set to null

     select childdbf, ;
            parentcol, ;
            childcol, ;
            nulltype, ;
            nullchar ;
       from li_rels ;
     having li_rels.dbfname = lc_alias ;
        and li_rels.delrule = "N" ;
       into cursor li_relate

     scan   
      select ( li_relate.childdbf )
      lc_dbf    = lc_alias + "." + ;
                  trim( li_relate.parentcol )
      lc_forkey = trim( li_relate.childdbf ) + "." + ;
                  trim( li_relate.childcol )
      lc_parent = eval( lc_alias + "." + ;
                  trim( li_relate.parentcol ) )
      lc_null   = trim( li_relate.nullchar )

      replace all (lc_forkey) with lc_null ;
              for lc_parent == eval( lc_forkey )
      select li_relate
     endscan

      select li_relate
      use
      select ( lc_alias )
      ll_oktodel = .t.

    case li_rels.delrule = "R"		&& Restrict

*-- I can't delete the record in this parent file if any records
*-- exist in the child files with the same foreign-primary key

     select dbfname, ;
            childdbf, ;
            parentcol, ;
            childcol, ;
            nulltype, ;
            nullchar, ;
            tagname ;
       from li_rels ;
     having li_rels.dbfname = lc_alias ;
        and li_rels.delrule = "R" ;
       into cursor li_relate

    ll_oktodel = .t.

    scan while ll_okscan

*-- Determine parent alias
      go top
      locate for dbfname = li_relate.dbfname
      lc_primary = alltrim( li_flist.aliasname )
      lc_forkey  = lc_primary + "." + ;
                   alltrim( li_relate.parentcol )

*-- Determine child alias 
      select li_flist
      go top
      locate for dbfname = li_relate.childdbf
      lc_chldals = alltrim( li_flist.aliasname )
      select ( lc_chldals )		&& Select the child alias

      lc_order = order()
      set order to ( li_relate.tagname )

       if seek( eval( lc_forkey ) )
        ll_oktodel = .f.
        =msgbox( li_msglist("NOTABLEDEL"), wtitle(wontop()), 48 )
        ll_okscan = .f.
       endif

       if !empty( lc_order )
        set order to ( lc_order )
       endif

     endscan
   endcase

else			&& No entries in table
 ll_oktodel = .t.
endif			&& Entries in delete rules table

if used("LI_RELATE")
 use in li_relate
endif

select( lc_alias )

if ll_oktodel
  delete 
  skip
  if eof()
    go bottom
  endif

 wait clear

 do li_waitmsg with "DELETEDONE", .f., .t., "", 2

endif

if lc_showget = "S"
 scatter memvar
 show gets
endif

return
*-- eop li_recdel



procedure li_fldpop
*-- Global foreign key validation procedure
*-- Parameters to send down are: 
*-- lu_value  = item you are seeking
*-- lc_table  = file to seek in
*-- lc_window = name of calling window; I know if closed during validation
*-- lc_msgkey = Reference in message table for title of popup
*-- ll_seek   = False will force the popup - Used by Seekitem.spr
*-- lc_key    = Foreign key that will be loaded into the current variable
*-- lc_fld1, lc_fld2 = additional field names used in prompt
*-- lc_footer = Footer of popup
*--
*--
*-- Last update: 08/13/93
*--
*--

parameters lu_value, ;
           lc_table, ;
           lc_window, ;
           lc_msgkey, ;
           ll_seek, ;
           lc_key, ;
           lc_fld1, ;
           lc_fld2

private ln_popwid, ;
        lc_sep, ;
        lc_alias, ;
        ln_params, ;
        ln_reccoun, ;
        ln_row, ;
        ln_col, ;
        lc_title, ;
        ll_found

ln_params = parameters()	&& minimum count is 6 more means lc_fld* has data
lc_sep    = chr(179)
lc_alias  = alias()
ln_row    = row()
ln_col    = col()
ll_found  = .f.

if .not. wvisible(lc_window)	&& window closed get out of the validation
 return .t.						&& read terminated in deactivate validation 
endif

select ( lc_table )

ll_found = seek( lu_value )

if ll_seek .and. ll_found
 select ( lc_alias )
 return .t.
else
 if eof()	&& If near is on, pointer will be close to location in file
  go top
 endif
endif 

*-- Accomodate numeric keys
if type( (lc_key) ) = "N"
 lc_uniqfld = str( eval( lc_key ))
else
 lc_uniqfld = eval(lc_key)
endif

ln_popwid  = len( lc_uniqfld + lc_sep ) + len( eval( lc_fld1 ) )
ln_row     = row()
ln_col     = col() 	&&+ 4
ln_reccoun = reccoun()

push key clear
set confirm on

if !empty( lc_msgkey )
 lc_title = li_msglist(lc_msgkey)	&& gets message from message file
else
 lc_title = "List"
endif

*       title lc_title ;

lc_sep = " "
if type( (lc_key) ) = "N"

define popup lp_pop ;
       from ln_row, ln_col ;
       in screen ;
       prompt field str( &lc_key ) + lc_sep + &lc_fld1

else

define popup lp_pop ;
       from ln_row, ln_col ;
       in screen ;
       prompt field &lc_key + lc_sep + &lc_fld1

endif

on selection popup lp_pop deactivate popup lp_pop
activate popup lp_pop rest
pop key

lu_value = eval( lc_key )
release popups lp_pop

set confirm off
select ( lc_alias )
return .t.
*-- eop 

procedure li_movewin
*-- Moves window just below and to the right of the previous window
*-- Called by all screens initially
*-- This module is NO GOOD for multiple window reads
*--
*-- Last update: 07/30/93
*-- 
*-- lc_window = Name of current window to move
*-- 
*--

parameters lc_window
*--
*-- Last update: 08/15/93
*--
private lc_wlast
lc_wlast = wontop()

if !empty( lc_wlast ) .and. lc_wlast <> "GW_MESSAGE"	&& if screen not last window
 move window &lc_window to wlrow(lc_wlast) + 1, wlcol(lc_wlast) + 2
else
 move window &lc_window to 1, 0		&& first on screen put in corner
endif

*-- eop li_movewin



*~!*********************************************
*~!
*~!       Procedure: li_moverec     
*~!
*~!*********************************************
PROCEDURE li_moverec     
*~  Author............: Valdis Matison
*~  Modified by.......: 
*~} Project...........: 
*~  Created...........: 03/26/1994
*~  Copyright.........: (c) Matison Consulting Group Inc., 1994
*~) Description.......: Moves record pointer and displays that record
*~)                     
*~] Dependencies......: 
*~  Calling Samples...: 
*~  Parameter List....: 
*~  Returns...........: 
*~  Future ideas......: 
*~  Major change list.: 
 
parameters ln_positn, lc_show
private lc_pos, ll_oktosho

if empty( lc_show )
 ll_oktosho = .f.
else
 ll_oktosho = .t.
endif

lc_pos=substr( "FPNL",ln_positn )

do case	
 case lc_pos = 'F'		&& First Record
  GO TOP	

 case lc_pos = 'N'		&& Next Record
  IF !EOF()
     SKIP 1
  ENDIF
   
  IF EOF()
     GO BOTTOM
     DO li_waitmsg WITH "EOF", gl_beep, .T., "", 2, "Y"
  ENDIF

 case lc_pos = 'P'		&& Previous

  IF !BOF()
     SKIP - 1
  ENDIF
   
  IF BOF()
     GO TOP
     DO li_waitmsg WITH "BOF", gl_beep, .T., "", 2, "Y"
  ENDIF

 case lc_pos = 'L'		&& Bottom
  go bottom

endcase

SCATTER MEMVAR MEMO
if ll_oktosho
 show gets
endif

*-- eop li_moverec



procedure li_wisetup
*-- Global window setup routine
*-- last update: 08/15/93
*--
*-- All global variables defined in core.prg

parameters lc_window, ;
           lc_proc, ;
           lc_key, ;
           lc_fldname, ;
           lc_seekmsg

private lc_saycol

lc_saycol  = scheme( 1,1 )		&& Say color in current color set

gn_close   = gn_close + 1
gc_proc    = lc_proc
gc_key     = lc_key
gc_fldname = lc_fldname
gc_seekmsg = lc_seekmsg

*if .NOT. wvisible( lc_window ) .and. wexist( lc_window )		&& first time into procedure
* do li_waitmsg with "SCRSETUP", .f., .t.
* do li_movewin with lc_window		&& open window at corner of previous
*endif

do li_tagpop						&& Create all popups for this screen

*-- eop li_wisetup



procedure li_wiclose
*-- Called from read deactivate
*--
*-- Last update: 05/03/93
*--
parameters lc_close

gl_adding  = .f.
gl_editing = .f.

*show get ln_positn disable

return .t.


procedure li_reclose
*-- Read Close Routine
*-- Cleanup Called from read exit 
*-- Activated when current windo is on top and another window
*-- is activated with a mouse click
*-- Last update: 08/15/93

private lc_key
lc_key     = lastkey()
gn_close   = gn_close - 1
gl_oktoadd = .t.
gl_hdline  = .f.		&& Allow table view to be active again
gl_adding  = .f.
gl_editing = .f.

if lc_key = gk_esckey .or. .not. wvisible( lc_window )	
  release window ( lc_window )
endif

* if gl_editing			&& Edited out for now but reintroduce later
* do li_savesta
* do li_okcanc with 3
* endif

*-- Only release if the window has not been changed to a browse
*-- and seekwindow or any other not activated

if .not. gl_browsin .and. gl_release
 release popups lp_order
endif

activate screen

*--
*-- eop 


*!*********************************************
*!
*!       Procedure: li_opendbf     
*!
*!*********************************************
PROCEDURE li_opendbf     
*  Author............: Valdis Matison
*} Project...........: 
*  Created...........: 10/17/93
*  Copyright.........: (c) Matison Consulting Group Inc., 1993
*) Description.......: Global procedure to open all files listed in li_flist
*)                     Closes all files first
*] Dependencies......: 
*  Calling Samples...: 
*  Parameter List....: 
*  Returns...........: 
*  Major change list.: 

private la_dbflist, ;
        lc_file

lc_error = on( "ERROR" )
close databases

if !file( "LI_FLIST.DBF" )
 do li_shutoff with "", "LI_FLIST not found. Shutting down system."
endif

select dbfname, ;
       tagname, ;
       mastertag, ;
       descrip ;
  from li_flist ;
 where ( alwaysopen .and. mastertag ) ;
 order by 1,3 ;
 into array la_dbflist

use

for ln_k = 1 to alen( la_dbflist,1 )
 do li_waitmsg with " ", .f., .t., "Opening file: " + alltrim(la_dbflist[ ln_k,4 ]), 0, "Y"

 lc_file = li_justfil( la_dbflist[ ln_k,1 ] ) +".CDX"
 if .not. file( lc_file )
  do li_singidx with li_justfil( lc_file )
 endif
 use la_dbflist[ ln_k,1 ] in (ln_k) order tag la_dbflist[ ln_k,2 ]
endfor

wait clear
do li_waitmsg with "FILESOPEN", .f., .t., "", 2

return
*--
*-- eop li_opendbf

procedure li_reclock
*-- Locks a single record
*--
*-- Last update: 04/26/93
*--
private ll_gotlock, ;
        lc_error

ll_gotlock = .f.
lc_error = on( "ERROR" )

ON ERROR DO li_recerr				&& error handler

SET REPROCESS to 3 seconds          && attempt lock for 3 seconds
ll_gotlock= .t.                     && initialize got lock flag

DO WHILE .not. RLOCK()              && Loop if rlock fails
  IF .not. li_recerr()             && call error routine, if returns .f.
     ll_gotlock=.f.                 && indicate we didn't get lock
     EXIT                           && exit the loop
  ENDIF
ENDDO

IF .not. ll_gotlock
 do li_waitmsg with "NORECLOCK", .t., .t.
ENDIF

on error &lc_error

RETURN ll_gotlock

****************
FUNCTION li_recerr		&& Example error handler
*--
*-- Simple error handler for lock routines
*-- Last update: 04/26/93
*--
private ll_retry, ;
        lc_ans

ll_retry = .f.
lc_ans = "N"

WAIT window "Record locked by another user. Try Again? (Y/N)" to lc_ans

IF UPPER( lc_ans ) = "Y"
 ll_retry = .t.		&& indicate retry
 RETRY				&& retry command that caused "error"
ELSE
 ll_retry = .f.		&& indicate no retry desired
ENDIF

RETURN ll_retry


*~!*********************************************
*~!
*~!       Procedure: li_shutoff     
*~!
*~!*********************************************
PROCEDURE li_shutoff     
*~  Author............: Valdis Matison
*~  Modified by.......: 
*~} Project...........: 
*~  Created...........: 10/25/1993
*~  Copyright.........: (c) Matison Consulting Group Inc., 1993
*~) Description.......: Closes down application. Probably due to an error
*~)                   : Make sure that li_msg is available if sending down
*~)                   : message key
*~] Dependencies......: 
*~  Calling Samples...: 
*~  Parameter List....: lc_msg: Name of key in messages table
*~                    : lc_text: Optional string to display 
*~  Returns...........: 
*~  Future ideas......: 
*~  Major change list.: 

parameters lc_msg, lc_text

wait clear

if !empty( lc_text )
 do li_waitmsg with "", .t., .t., lc_text, 5, "R" 
else
 do li_waitmsg with lc_msg, .t., .t., "", 5, "R"
endif

close databases
quit

*--
*-- eop li_shutdown


*~!*********************************************
*~!
*~!       Procedure: li_popoff      
*~!
*~!*********************************************
PROCEDURE li_popoff      
*~  Author............: Valdis Matison
*~  Modified by.......: 
*~} Project...........: 
*~  Created...........: 11/05/93
*~  Copyright.........: (c) Matison Consulting Group Inc., 1993
*~) Description.......: Turns popups offs selectively
*~)                   : The set skip of pad function only works with the 
*~)                   : FoxPro system menu so it's no good 
*~)                   : WARNING! Popups are hard-coded for each application
*~)                   : Room for 12 menu popups, If first # is 99 turn all off
*~] Dependencies......: Needs li_popon to reinitialize the popups
*~]                   : Global array of popup names must already be intialized
*~  Calling Samples...: do li_popoff with 1, 2, 5
*~                    : Turns off 1st, 2nd, 5th menus
*~  Parameter List....: 
*~  Returns...........: 
*~  Comments..........: Don't like the way this code works with macro exp
*~  Future ideas......: Change the macro expansion
*~  Major change list.: 

parameters ln_a, ln_b, ln_c, ln_d, ln_e, ln_f, ;
           ln_g, ln_h, ln_i, ln_j, ln_k, ln_l

external array ga_menupop

for ln_k = 1 to parameters()
 lc_param = "ln_" + substr("abcdefghijkl", ln_k, 1)
 ln_value = eval( lc_param )
 set skip of popup ( ga_menupop[ ln_value ] ) .t.
endfor

*--
*-- eop li_popoff


*~!*********************************************
*~!
*~!       Procedure: li_popon      
*~!
*~!*********************************************
PROCEDURE li_popon      
*~  Author............: Valdis Matison
*~  Modified by.......: 
*~} Project...........: 
*~  Created...........: 11/05/93
*~  Copyright.........: (c) Matison Consulting Group Inc., 1993
*~) Description.......: Turns popups offs selectively
*~)                   : The set skip of pad function only works with the 
*~)                   : FoxPro system menu so it's no good 
*~)                   : WARNING! Popups are hard-coded for each application
*~)                   : Room for 12 menu popups, If first # is 99 turn all off
*~] Dependencies......: Needs li_popon to reinitialize the popups
*~  Calling Samples...: do li_popon with 1, 2, 5
*~                    : Turns off 1st, 2nd, 5th menus
*~  Parameter List....: 
*~  Returns...........: 
*~  Comments..........: Don't like the way this code works with macro exp
*~  Future ideas......: Change the macro expansion
*~  Major change list.: 

parameters ln_a, ln_b, ln_c, ln_d, ln_e, ln_f, ;
           ln_g, ln_h, ln_i, ln_j, ln_k, ln_l

external array ga_menupop


for ln_k = 1 to parameters()
 lc_param = "ln_" + substr("abcdefghijkl", ln_k, 1)
 ln_value = eval( lc_param )
 set skip of popup ( ga_menupop[ ln_value ] ) .f.
endfor

*--
*-- eop li_popon


procedure li_settag
* Last update: 03/29/84
*-- ASSUMES THAT LA_TAGNAME HAS ALREADY BEEN DEFINED
private ln_tagcnt, ln_k

ln_tagcnt = 1
ln_k      = 1

dime la_tagname[1,2]

do while .not. empty( tag(ln_k) )

 if upper( trim( tag( ln_k ) ) ) <> "DELETED"
  dime la_tagname[ ln_tagcnt,2 ]
  la_tagname[ ln_tagcnt,1 ] = li_msglist( alias()+tag(ln_k))
  la_tagname[ ln_tagcnt,2 ] = tag( ln_k )
  ln_tagcnt = ln_tagcnt + 1
 endif
 
 ln_k = ln_k + 1
enddo

*-- eop li_settag


*!*********************************************
*!
*!       Procedure: li_justfil     
*!
*!*********************************************
PROCEDURE li_justfil     
*  Author............: Walter Kennamer 
*  Modified by.......: Valdis Matison
*} Project...........: 
*  Created...........: 10/17/93
*  Copyright.........: (c) Matison Consulting Group Inc., 1993
*) Description.......: Return just the filename (i.e., no path) from "lc_file"
*)                     No extension either
*] Dependencies......: 
*  Calling Samples...: lc_file = li_justfil( "c:\autoexec.bat" )
*  Parameter List....: 
*  Returns...........: 
*  Major change list.: 
 
parameters lc_file
if rat('\',lc_file) > 0
   lc_file = substr( lc_file, RAT( '\',lc_file )+1,255 )
endif

if at(':', lc_file) > 0
   lc_file = substr( lc_file, at( ':', lc_file )+1,255 )
endif

*-- This next line was added by me to get rid of the "." for
*-- files less than 8 characters
*--
if at('.',lc_file) > 0
   lc_file = substr( lc_file, 1, AT( '.',lc_file ) - 1 )
endif

return alltrim( upper( lc_file ) )
*--
*-- eop li_justfil


*!*********************************************************************
*!
*!      Procedure: JUSTPATH
*!
*!      Called by: DEFAULTEXT()   (function  in GENXTAB.PRG)
*!               : FORCEEXT       (procedure in GENXTAB.PRG)
*!
*!*********************************************************************
FUNCTION justpath
* Return just the path name from "filname"
PARAMETERS filname
PRIVATE ALL
m.filname = ALLTRIM(UPPER(m.filname))
IF '\' $ m.filname
   m.filname = SUBSTR(m.filname,1,RAT('\',m.filname))
   IF RIGHT(m.filname,1) = '\' AND LEN(m.filname) > 1 ;
         AND SUBSTR(m.filname,LEN(m.filname)-1,1) <> ':'
      m.filname = SUBSTR(m.filname,1,LEN(m.filname)-1)
   ENDIF
   RETURN m.filname
ELSE
   RETURN ''
ENDIF
